<!doctype html>
<html lang="en" data-bs-theme="auto">

<head>
  <script src="assets/js/color-modes.js"></script>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="description" content="">
  <meta name="author" content="Mark Otto, Jacob Thornton, and Bootstrap contributors">
  <meta name="generator" content="Hugo 0.111.3">
  <title>Starter Template · Bootstrap v5.3</title>

  <link rel="canonical" href="https://getbootstrap.com/docs/5.3/examples/starter-template/">





  <link href="assets/dist/css/bootstrap.min.css" rel="stylesheet">

  <style>
    .bd-placeholder-img {
      font-size: 1.125rem;
      text-anchor: middle;
      -webkit-user-select: none;
      -moz-user-select: none;
      user-select: none;
    }

    @media (min-width: 768px) {
      .bd-placeholder-img-lg {
        font-size: 3.5rem;
      }
    }

    .b-example-divider {
      width: 100%;
      height: 3rem;
      background-color: rgba(0, 0, 0, .1);
      border: solid rgba(0, 0, 0, .15);
      border-width: 1px 0;
      box-shadow: inset 0 .5em 1.5em rgba(0, 0, 0, .1), inset 0 .125em .5em rgba(0, 0, 0, .15);
    }

    .b-example-vr {
      flex-shrink: 0;
      width: 1.5rem;
      height: 100vh;
    }

    .bi {
      vertical-align: -.125em;
      fill: currentColor;
    }

    .nav-scroller {
      position: relative;
      z-index: 2;
      height: 2.75rem;
      overflow-y: hidden;
    }

    .nav-scroller .nav {
      display: flex;
      flex-wrap: nowrap;
      padding-bottom: 1rem;
      margin-top: -1px;
      overflow-x: auto;
      text-align: center;
      white-space: nowrap;
      -webkit-overflow-scrolling: touch;
    }

    .btn-bd-primary {
      --bd-violet-bg: #712cf9;
      --bd-violet-rgb: 112.520718, 44.062154, 249.437846;

      --bs-btn-font-weight: 600;
      --bs-btn-color: var(--bs-white);
      --bs-btn-bg: var(--bd-violet-bg);
      --bs-btn-border-color: var(--bd-violet-bg);
      --bs-btn-hover-color: var(--bs-white);
      --bs-btn-hover-bg: #6528e0;
      --bs-btn-hover-border-color: #6528e0;
      --bs-btn-focus-shadow-rgb: var(--bd-violet-rgb);
      --bs-btn-active-color: var(--bs-btn-hover-color);
      --bs-btn-active-bg: #5a23c8;
      --bs-btn-active-border-color: #5a23c8;
    }

    .bd-mode-toggle {
      z-index: 1500;
    }
  </style>


</head>

<body>
  <svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
    <symbol id="check2" viewBox="0 0 16 16">
      <path
        d="M13.854 3.646a.5.5 0 0 1 0 .708l-7 7a.5.5 0 0 1-.708 0l-3.5-3.5a.5.5 0 1 1 .708-.708L6.5 10.293l6.646-6.647a.5.5 0 0 1 .708 0z" />
    </symbol>
    <symbol id="circle-half" viewBox="0 0 16 16">
      <path d="M8 15A7 7 0 1 0 8 1v14zm0 1A8 8 0 1 1 8 0a8 8 0 0 1 0 16z" />
    </symbol>
    <symbol id="moon-stars-fill" viewBox="0 0 16 16">
      <path
        d="M6 .278a.768.768 0 0 1 .08.858 7.208 7.208 0 0 0-.878 3.46c0 4.021 3.278 7.277 7.318 7.277.527 0 1.04-.055 1.533-.16a.787.787 0 0 1 .81.316.733.733 0 0 1-.031.893A8.349 8.349 0 0 1 8.344 16C3.734 16 0 12.286 0 7.71 0 4.266 2.114 1.312 5.124.06A.752.752 0 0 1 6 .278z" />
      <path
        d="M10.794 3.148a.217.217 0 0 1 .412 0l.387 1.162c.173.518.579.924 1.097 1.097l1.162.387a.217.217 0 0 1 0 .412l-1.162.387a1.734 1.734 0 0 0-1.097 1.097l-.387 1.162a.217.217 0 0 1-.412 0l-.387-1.162A1.734 1.734 0 0 0 9.31 6.593l-1.162-.387a.217.217 0 0 1 0-.412l1.162-.387a1.734 1.734 0 0 0 1.097-1.097l.387-1.162zM13.863.099a.145.145 0 0 1 .274 0l.258.774c.115.346.386.617.732.732l.774.258a.145.145 0 0 1 0 .274l-.774.258a1.156 1.156 0 0 0-.732.732l-.258.774a.145.145 0 0 1-.274 0l-.258-.774a1.156 1.156 0 0 0-.732-.732l-.774-.258a.145.145 0 0 1 0-.274l.774-.258c.346-.115.617-.386.732-.732L13.863.1z" />
    </symbol>
    <symbol id="sun-fill" viewBox="0 0 16 16">
      <path
        d="M8 12a4 4 0 1 0 0-8 4 4 0 0 0 0 8zM8 0a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-1 0v-2A.5.5 0 0 1 8 0zm0 13a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-1 0v-2A.5.5 0 0 1 8 13zm8-5a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1 0-1h2a.5.5 0 0 1 .5.5zM3 8a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1 0-1h2A.5.5 0 0 1 3 8zm10.657-5.657a.5.5 0 0 1 0 .707l-1.414 1.415a.5.5 0 1 1-.707-.708l1.414-1.414a.5.5 0 0 1 .707 0zm-9.193 9.193a.5.5 0 0 1 0 .707L3.05 13.657a.5.5 0 0 1-.707-.707l1.414-1.414a.5.5 0 0 1 .707 0zm9.193 2.121a.5.5 0 0 1-.707 0l-1.414-1.414a.5.5 0 0 1 .707-.707l1.414 1.414a.5.5 0 0 1 0 .707zM4.464 4.465a.5.5 0 0 1-.707 0L2.343 3.05a.5.5 0 1 1 .707-.707l1.414 1.414a.5.5 0 0 1 0 .708z" />
    </symbol>
  </svg>

  <div class="dropdown position-fixed bottom-0 end-0 mb-3 me-3 bd-mode-toggle">
    <button class="btn btn-bd-primary py-2 dropdown-toggle d-flex align-items-center" id="bd-theme" type="button"
      aria-expanded="false" data-bs-toggle="dropdown" aria-label="Toggle theme (auto)">
      <svg class="bi my-1 theme-icon-active" width="1em" height="1em">
        <use href="#circle-half"></use>
      </svg>
      <span class="visually-hidden" id="bd-theme-text">Toggle theme</span>
    </button>
    <ul class="dropdown-menu dropdown-menu-end shadow" aria-labelledby="bd-theme-text">
      <li>
        <button type="button" class="dropdown-item d-flex align-items-center" data-bs-theme-value="light"
          aria-pressed="false">
          <svg class="bi me-2 opacity-50 theme-icon" width="1em" height="1em">
            <use href="#sun-fill"></use>
          </svg>
          Light
          <svg class="bi ms-auto d-none" width="1em" height="1em">
            <use href="#check2"></use>
          </svg>
        </button>
      </li>
      <li>
        <button type="button" class="dropdown-item d-flex align-items-center" data-bs-theme-value="dark"
          aria-pressed="false">
          <svg class="bi me-2 opacity-50 theme-icon" width="1em" height="1em">
            <use href="#moon-stars-fill"></use>
          </svg>
          Dark
          <svg class="bi ms-auto d-none" width="1em" height="1em">
            <use href="#check2"></use>
          </svg>
        </button>
      </li>
      <li>
        <button type="button" class="dropdown-item d-flex align-items-center active" data-bs-theme-value="auto"
          aria-pressed="true">
          <svg class="bi me-2 opacity-50 theme-icon" width="1em" height="1em">
            <use href="#circle-half"></use>
          </svg>
          Auto
          <svg class="bi ms-auto d-none" width="1em" height="1em">
            <use href="#check2"></use>
          </svg>
        </button>
      </li>
    </ul>
  </div>


  <svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
    <symbol id="arrow-right-circle" viewBox="0 0 16 16">
      <path
        d="M8 0a8 8 0 1 1 0 16A8 8 0 0 1 8 0zM4.5 7.5a.5.5 0 0 0 0 1h5.793l-2.147 2.146a.5.5 0 0 0 .708.708l3-3a.5.5 0 0 0 0-.708l-3-3a.5.5 0 1 0-.708.708L10.293 7.5H4.5z" />
    </symbol>
    <symbol id="bootstrap" viewBox="0 0 118 94">
      <title>Bootstrap</title>
      <path fill-rule="evenodd" clip-rule="evenodd"
        d="M24.509 0c-6.733 0-11.715 5.893-11.492 12.284.214 6.14-.064 14.092-2.066 20.577C8.943 39.365 5.547 43.485 0 44.014v5.972c5.547.529 8.943 4.649 10.951 11.153 2.002 6.485 2.28 14.437 2.066 20.577C12.794 88.106 17.776 94 24.51 94H93.5c6.733 0 11.714-5.893 11.491-12.284-.214-6.14.064-14.092 2.066-20.577 2.009-6.504 5.396-10.624 10.943-11.153v-5.972c-5.547-.529-8.934-4.649-10.943-11.153-2.002-6.484-2.28-14.437-2.066-20.577C105.214 5.894 100.233 0 93.5 0H24.508zM80 57.863C80 66.663 73.436 72 62.543 72H44a2 2 0 01-2-2V24a2 2 0 012-2h18.437c9.083 0 15.044 4.92 15.044 12.474 0 5.302-4.01 10.049-9.119 10.88v.277C75.317 46.394 80 51.21 80 57.863zM60.521 28.34H49.948v14.934h8.905c6.884 0 10.68-2.772 10.68-7.727 0-4.643-3.264-7.207-9.012-7.207zM49.948 49.2v16.458H60.91c7.167 0 10.964-2.876 10.964-8.281 0-5.406-3.903-8.178-11.425-8.178H49.948z">
      </path>
    </symbol>
  </svg>

  <div class="col-lg-9 mx-auto p-4 py-md-5">
    <header class="d-flex align-items-center pb-3 mb-5 border-bottom">
      <a href="/" class="d-flex align-items-center text-body-emphasis text-decoration-none">
        <span class="fs-4">Diffie-Hellman Key Exchange</span>
      </a>
    </header>

    <main>
      <h1></h1>
      <h2>Contant</h2>
      <div class="row">
        <div class="col-3">
          <div class="mb-3">
            <label for="largePrimeDigits" class="form-label">Prime Digits</label>
            <input type="number" class="form-control" id="largePrimeDigits" placeholder="20" value="20">
          </div>
        </div>
        <div class="col-auto">
          <label class="form-label">1️⃣</label>
          <button type="button" class="btn btn-primary mb-3 form-control" onclick="getPrimeNumbers()">1. Generate Prime
            and
            Primitive
            root</button>
        </div>
        <!-- <div class="col-auto">
          <label class="form-label">1️⃣</label>
          <button type="button" class="btn btn-primary mb-3 form-control" onclick="runAll()">Run All</button>
        </div> -->
      </div>
      <div class="row">
        <div class="col-5">
          <div class="mb-3">
            <label for="largePrime" class="form-label">Large Prime <b>(q)</b></label>
            <input type="number" class="form-control" id="largePrime" readonly></input>
          </div>
        </div>
        <div class="col-3">
          <div class="mb-3">
            <label for="primitiveRoot" class="form-label">Primitive Root <b>(a)</b></label>
            <input type="number" class="form-control" id="primitiveRoot" readonly></input>
          </div>
        </div>
      </div>

      <div class="row">
        <div class="col-6">
          <h2>User A</h2>
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="aKeyLength" class="form-label">Key Length</label>
                <input type="number" class="form-control" id="aKeyLength" placeholder="10" value="10">
              </div>
            </div>
            <div class="col-6">
              <div class="mb-3">
                <label for="aGeneratePrivateKey" class="form-label">2️⃣</label>
                <button id="aGeneratePrivateKey" type="button" class="btn btn-primary mb-3 form-control"
                  onclick="generatePrivateKey('aKeyLength')">2. Generate Private Key <b>(X<sub>A</sub>)</b></button>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="APrivateKey" class="form-label">Private key <b>(X<sub>A</sub>)</b></label>
                <input type="number" class="form-control" id="APrivateKey"></input>
                <div class="form-text">
                  <b>X<sub>A</sub> < q</b>
              </div>
              </div>
            </div>
            <div class="col-6">
              <label for="calculateAPublicKey" class="form-label">🧮</label>
              <button id="calculateAPublicKey" type="button" class="btn btn-primary mb-3 form-control"
                onclick="calculatePublicKey('APrivateKey')">Calculate Public Key <b>(Y<sub>A</sub>)</b></button>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <div class="mb-3">
                <label for="APublicKey" class="form-label">Public key (<b>Y<sub>A</sub></b>)</label>
                <input type="number" class="form-control" id="APublicKey" readonly></input>
                <div class="form-text">
                    <b>Y<sub>A</sub> = a<sup>X<sub>A</sub></sup> mod q</b>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-6">
          <h2>User B</h2>
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="bKeyLength" class="form-label">Key Length</label>
                <input type="number" class="form-control" id="bKeyLength" placeholder="10" value="10">
              </div>
            </div>
            <div class="col-6">
              <div class="mb-3">
                <label for="bGeneratePrivateKey" class="form-label">3️⃣</label>
                <button id="bGeneratePrivateKey" type="button" class="btn btn-primary mb-3 form-control"
                  onclick="generatePrivateKey('bKeyLength')">3. Generate Private Key <b>(X<sub>B</sub>)</b></button>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-6">
              <div class="mb-3">
                <label for="BPrivateKey" class="form-label">Private key <b>(X<sub>B</sub>)</b></label>
                <input type="number" class="form-control" id="BPrivateKey"></input>
                <div class="form-text">
                    <b>X<sub>B</sub> < q</b>
                </div>
              </div>
            </div>
            <div class="col-6">
              <div class="mb-3">
                <label for="calculateBPublicKey" class="form-label">🧮</label>
                <button id="calculateBPublicKey" type="button" class="btn btn-primary mb-3 form-control"
                  onclick="calculatePublicKey('BPrivateKey')">Calculate Public Key <b>(Y<sub>B</sub>)</b></button>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <div class="mb-3">
                <label for="BPublicKey" class="form-label">Public key <b>(Y<sub>B</sub>)</b></label>
                <input type="number" class="form-control" id="BPublicKey" readonly></input>
                <div class="form-text">
                    <b>Y<sub>B</sub> = a<sup>X<sub>B</sub></sup> mod q</b>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="mb-3">
        <h2>Shared secret <b>K<sub>AB</sub></b></h2>
      </div>
      <div class="row">
        <div class="col-6">
          <div class="mb-3">
            <label for="aCalculateSharedKey" class="form-label">4️⃣</label>
            <button id="aCalculateSharedKey" type="button" class="btn btn-primary mb-3 form-control"
              onclick="calculateSharedKey('A')" data-role="A">4. Calculate Shared Key <b>K<sub>AB</sub></b></button>
          </div>
          <div class="mb-3">
            <label for="ASharedKey" class="form-label">Shared key <b>K<sub>AB</sub></b></label>
            <input type="number" class="form-control" id="ASharedKey" readonly></input>
            <div id="ASharedKeyHelpBlock" class="form-text">
              <b>K<sub>AB</sub></b>=<b>Y<sub>B</sub><sup>X<sub>A</sub></sup> mod q</b>
            </div>
          </div>
        </div>
        <div class="col-6">
          <div class="mb-3">
            <label for="bCalculateSharedKey" class="form-label">4️⃣</label>
            <button id="bCalculateSharedKey" type="button" class="btn btn-primary mb-3 form-control"
              onclick="calculateSharedKey('B')" data-role="B">5. Calculate Shared Key
              <b>K<sub>BA</sub></b></button>
          </div>
          <div class="mb-3">
            <label for="BSharedKey" class="form-label">Shared key <b>K<sub>BA</sub></b></label>
            <input type="number" class="form-control" id="BSharedKey" readonly></input>
            <div id="BSharedKeyHelpBlock" class="form-text">
              <b>K<sub>BA</sub></b>=<b>Y<sub>A</sub><sup>X<sub>B</sub></sup> mod q</b>
            </div>
          </div>

        </div>
      </div>
    </main>
    <footer class="pt-5 my-5 text-body-secondary border-top">
      Created by the Bootstrap team &middot; &copy; 2023
    </footer>
  </div>


  <script src="assets/dist/js/bootstrap.bundle.min.js"></script>
  <script>
    const API_URL = "https://cis-2023-api.agase.xyz/"
    // const API_URL = "http://localhost:8000/"

    function runAll() {
      getPrimeNumbers()
      generatePrivateKey('aKeyLength')
      generatePrivateKey('bKeyLength')
      calculateSharedKey("A")
      calculateSharedKey("B")
    }
    function calculateSharedKey(role) {
      var other = role == "A" ? "B" : "A";

      largePrime = document.getElementById("largePrime").value;
      otherPublicKey = document.getElementById(`${other}PublicKey`).value;
      selfPrivateKey = document.getElementById(`${role}PrivateKey`).value;
      console.log({ largePrime, otherPublicKey, selfPrivateKey })

      const url = `${API_URL}mod-exponent?base=${otherPublicKey}&exp=${selfPrivateKey}&mod=${largePrime}`;

      fetch(url)
        .then(response => response.json())
        .then(data => {
          // Process the returned data here
          console.log(data);
          document.getElementById(`${role}SharedKey`).value = data.result;
        })
        .catch(error => {
          // Handle any errors that occur during the request
          console.error('Error:', error);
        });
    }

    function calculatePublicKey(elem_id) {
      var largePrimeElement = document.getElementById('largePrime');
      var primitiveRootElement = document.getElementById('primitiveRoot');
      var largePrime = largePrimeElement.value
      var primitiveRoot = primitiveRootElement.value

      var elem = document.getElementById(elem_id)
      var private_key = elem.value
      var public_key_field_id = elem_id == "APrivateKey" ? "APublicKey" : "BPublicKey"

      const url = `${API_URL}mod-exponent?base=${primitiveRoot}&exp=${private_key}&mod=${largePrime}`;

      fetch(url)
        .then(response => response.json())
        .then(data => {
          // Process the returned data here
          console.log(data);
          var PublicKeyElem = document.getElementById(public_key_field_id);
          PublicKeyElem.value = data.result;
        })
        .catch(error => {
          // Handle any errors that occur during the request
          console.error('Error:', error);
        });



    }

    function generatePrivateKey(elem_id) {
      var elem = document.getElementById(elem_id)
      var key_length = elem.value
      var elem = document.getElementById("largePrime")
      var max_val = elem.value - 1


      const url = `${API_URL}get-random-number?digits=${key_length}&max_val=${max_val}`;

      var private_key_field_id = elem_id == "aKeyLength" ? "APrivateKey" : "BPrivateKey"
      var calculatePublicKeyParameter = elem_id == "aKeyLength" ? "APrivateKey" : "BPrivateKey"
      fetch(url)
        .then(response => response.json())
        .then(data => {
          // Process the returned data here
          console.log(data);
          var PrivateKeyElem = document.getElementById(private_key_field_id);
          PrivateKeyElem.value = data.num;
          calculatePublicKey(calculatePublicKeyParameter);
        })
        .catch(error => {
          // Handle any errors that occur during the request
          console.error('Error:', error);
        });
    }

    function getPrimeNumbers() {
      const digitsInput = document.getElementById('largePrimeDigits');
      const digitsValue = digitsInput.value;

      const url = `${API_URL}get-prime?digits=${digitsValue}`;

      fetch(url)
        .then(response => response.json())
        .then(data => {
          // Process the returned data here
          console.log(data);
          var largePrimeElement = document.getElementById('largePrime');
          var primitiveRootElement = document.getElementById('primitiveRoot');
          var largePrimeDigitsElement = document.getElementById('largePrimeDigits');
          var castedPrime = parseInt(data.prime)
          largePrimeElement.value = data.prime;
          primitiveRootElement.value = data.root;
          largePrimeDigitsElement.value = data.digits;
        })
        .catch(error => {
          // Handle any errors that occur during the request
          console.error('Error:', error);
        });
    }
  </script>

</body>

</html>